#!/usr/bin/env python
#-*- coding: UTF-8 -*-

import sys
import wx
import os
from   .nofyhistmisc import *


class AboutDialog(wx.Dialog):
    def __init__(self, parent):
        """ place About items on dialog """
        wx.Dialog.__init__(self, parent, -1, TITLE + ' - About')
        btnadj = int(parent.config['Gui']['norm'] == 'False')
        sizer = wx.BoxSizer(wx.VERTICAL)
        sb = wx.StaticBox(self, -1, ' %s ' % VERSION)
        sbsz = wx.StaticBoxSizer(sb, wx.VERTICAL)
        row1 = wx.BoxSizer(wx.HORIZONTAL)
        png = wx.Image(ICONPATH + os.sep + APPICON, wx.BITMAP_TYPE_PNG).ConvertToBitmap()
        bm = wx.StaticBitmap(self, -1, png, wx.Point(10, 10), (png.GetWidth(), png.GetHeight()))
        row1.Add(bm, 0, wx.RIGHT, BORDER)
        s0 = _('release date')
        pyversion = _('running on Python - Version %s') % sys.version.split()[0]
        wxversion = _('using wxPython - Version %s') % wx.VERSION_STRING
        platforminfo = _('wx Platform Info - %s') % PSTRING               
        st = wx.StaticText(self, -1, '\n\n> %s - %s\n> %s\n> %s\n> %s' %
                           (s0, RELEASEDATE, pyversion, wxversion, platforminfo),
                           pos = wx.Point(30 + png.GetWidth(), BORDER))
        row1.Add(st, 0, wx.LEFT, BORDER)
        sbsz.Add(row1, 0, wx.GROW | wx.ALL, BORDER)

        row2 = wx.BoxSizer(wx.HORIZONTAL)
        s0 = _('With NofyHist - the Notification History - you can:')
        s1 = _('> show recent notifications') 
        s2 = _('> set exclude filters for unwanted senders')
        s3 = _('> search in the notifications history') 
        s4 = _('> write notifications to a log file')
        s5 = _('Frank Mersmann (design and coding) - frank.mersmann@gmail.com') 
        s6 = _('Wolfgang Bredow (testing and hints) - bredow.w@googlemail.com')              
        s = s0 + '\n' + s1 + '\n' + s2 + '\n' + s3 + '\n' + s4 + '\n\n' + s5 + '\n' + s6
        st = wx.StaticText(self, -1, s)
        row2.Add(st, 0, wx.LEFT | wx.RIGHT, BORDER)
        sbsz.Add(row2, 0, wx.GROW | wx.ALL, BORDER)
        sizer.Add(sbsz, 0, wx.GROW | wx.ALL, BORDER)

        row3 = wx.BoxSizer(wx.HORIZONTAL)
        if not btnadj: row3.AddStretchSpacer()
        butok = wx.Button(self, wx.ID_OK)
        row3.Add(butok, btnadj, wx.GROW | wx.LEFT | wx.RIGHT | wx.BOTTOM, GAP)

        sizer.Add(row3, 1,  wx.GROW | wx.LEFT | wx.RIGHT | wx.BOTTOM, GAP)
        self.SetSizer(sizer)
        self.Fit()
        self.Centre()
# - class AboutDialog(wx.Dialog):---------------------------------------------------------------
