#!/usr/bin/env python
#-*- coding: UTF-8 -*-

import sys
import wx
import os
from   .nofyhistmisc import *


class ExcludeDialog(wx.Dialog):
    
    ID_TC_FTYPE = wx.NewId()
    
    def __init__(self, parent, config, messages):
        wx.Dialog.__init__(self, parent, -1, TITLE + _(' - edit exclude Sender masks'))
        btnadj = int(config['Gui']['norm'] == 'False')
        self.config = config
        self.selectindex = len(self.config['Misc']['exclude']) - 1
        self.readonly_color = wx.SystemSettings_GetColour(READONLY_COLOR)
        self.isadd = False
        
        senders = []
        for message in messages:
            if message[0] not in senders:
                senders.append(message[0])
        if len(senders) == 0:
            senders = [_('Example')]
        sizer = wx.BoxSizer(wx.VERTICAL)  
        ftsz = wx.FlexGridSizer(3, 1, 0, 0)
        ftsz.AddGrowableCol(0)
        ftsz.AddGrowableRow(0)

        self.lbft = wx.ListBox(self, -1, style = wx.LB_SINGLE | wx.LB_HSCROLL)
        ftsz.Add(self.lbft, 1, wx.GROW | wx.ALL, GAP)
        self.Bind(wx.EVT_LISTBOX, self.onSelected)
        self.Bind(wx.EVT_LISTBOX_DCLICK, self.onButtonEdit)
        self.updateListBox()

        self.cbx = wx.ComboBox(self, -1, senders[0],
                               choices = senders) #     style = wx.TE_PROCESS_ENTER)        
        ftsz.Add(self.cbx, 0, wx.GROW | wx.ALL, GAP)
#        self.Bind(wx.EVT_TEXT_ENTER, self.onSelect, self.cbx)
        self.cbx.SetMark(0, -1)
        sizer.Add(ftsz, 1, wx.GROW | LRT, BORDER)    

        butadd = wx.Button(self, wx.ID_ADD)
        butrem = wx.Button(self, wx.ID_REMOVE)
        butclose = wx.Button(self, wx.ID_CLOSE)
        self.Bind(wx.EVT_BUTTON, self.onButtonAdd, id = wx.ID_ADD)
        self.Bind(wx.EVT_BUTTON, self.onButtonRem, id = wx.ID_REMOVE)
        self.Bind(wx.EVT_BUTTON, self.onButtonClose, id = wx.ID_CLOSE)

        butsz = wx.BoxSizer(wx.HORIZONTAL)
        butsz.Add(butadd, 1, wx.GROW | wx.ALL, GAP)
        butsz.Add(butrem, 1, wx.GROW | wx.ALL, GAP)
        butsz.Add(butclose, 1, wx.GROW | wx.ALL, GAP)
        sizer.Add(butsz, 0, wx.GROW | wx.LEFT | wx.RIGHT, BORDER)
           
        self.SetSizer(sizer)
        self.SetMinSize(wx.Size(350, 220))
        self.Fit()
        self.Centre()
    #-------------------------------------------------------------------------------------------

    def updateListBox(self):
        self.lbft.Clear()
        self.config['Misc']['exclude'].sort()
        self.lbft.Set(self.config['Misc']['exclude'])
        self.lbft.SetFocus()
        try:
            self.lbft.Select(self.selectindex)
        except:
            pass
    #-------------------------------------------------------------------------------------------

    def onSelected(self, event):
        selectindex = event.GetSelection()
        if selectindex >= 0:
            self.selectindex = selectindex
    #-------------------------------------------------------------------------------------------

    def onButtonAdd(self, event):
        newmask = self.cbx.GetValue().strip()
        if newmask not in self.config['Misc']['exclude']:
             self.config['Misc']['exclude'].append(newmask)
        self.updateListBox()
    #-------------------------------------------------------------------------------------------

    def onButtonRem(self, event):
        if self.selectindex != - 1:
            del self.config['Misc']['exclude'][self.selectindex]          
            self.selectindex = len(self.config['Misc']['exclude']) - 1
            self.updateListBox()
    #-------------------------------------------------------------------------------------------

    def onButtonEdit(self, event = None):
        self.tcft.Clear()
        if not self.isadd:
            self.tcft.WriteText(self.config['Misc']['exclude'][self.selectindex])
        self.tcft.SetEditable(True)
        self.tcft.SetBackgroundColour(wx.SystemSettings_GetColour(wx.SYS_COLOUR_WINDOW))
        self.msgtext.SetLabel(self.EDITMSG)
        font = wx.Font(8, wx.DEFAULT, wx.NORMAL, wx.NORMAL)
        self.msgtext.SetFont(font)        
        self.tcft.SetFocusFromKbd()
        self.tcft.SetInsertionPointEnd()
    #-------------------------------------------------------------------------------------------

    def onButtonClose(self, event):
        self.Destroy()
# - class ExcludeDialog(wx.Dialog):-------------------------------------------------------------
